DECLARE
   CURSOR     emp_dept_cr IS
                 SELECT empno,ename,sal,loc
                 FROM emp JOIN dept
                 ON emp.deptno = dept.deptno
                 WHERE loc = 'DALLAS'
                 AND   sal < 2500
                 FOR UPDATE OF sal;
   emp_record emp_dept_cr%ROWTYPE;
BEGIN
   OPEN emp_dept_cr;
      LOOP
         FETCH emp_dept_cr INTO emp_record;
         EXIT WHEN emp_dept_cr%NOTFOUND;
            UPDATE emp SET sal = emp_record.sal * 1.08
            WHERE CURRENT OF emp_dept_cr;
      END LOOP;
   CLOSE emp_dept_cr;
END; 
/