DECLARE
   dept_up      NUMBER;
   rate         CONSTANT NUMBER := 1.5;
   CURSOR       emp_cr IS 
                   SELECT empno,sal,deptno FROM emp;
   emp_rec      emp_cr%ROWTYPE;
   sal_no_data  EXCEPTION;
BEGIN
   OPEN emp_cr;
      LOOP
         FETCH emp_cr INTO emp_rec;
         EXIT WHEN emp_cr%NOTFOUND;
            IF emp_rec.sal IS NULL
               THEN RAISE sal_no_data;
            END IF;
               CASE emp_rec.deptno
                  WHEN 10 THEN dept_up := 2.0;
                  WHEN 20 THEN dept_up := 2.5;
                  WHEN 30 THEN dept_up := 3.0;
                  WHEN 40 THEN dept_up := 3.5;
               ELSE dept_up := rate;
               END CASE;
                  UPDATE emp SET sal = TRUNC(sal * dept_up)
                  WHERE empno = emp_rec.empno;
      END LOOP;
   CLOSE emp_cr;
EXCEPTION
   WHEN sal_no_data
   THEN raise_application_error(-20001,'^̃f[^݂܂');
END;
/