CREATE OR REPLACE PROCEDURE pro_update_newsal
IS
   dept_up   NUMBER;
   sal_new   emp.sal%TYPE;
   CURSOR    emp_cr IS
                SELECT empno,sal,deptno FROM emp
                FOR UPDATE;
   emp_rec   emp_cr%ROWTYPE;
BEGIN
   OPEN emp_cr;
      LOOP
         FETCH emp_cr INTO emp_rec;
         EXIT WHEN emp_cr%NOTFOUND;
            CASE emp_rec.deptno
               WHEN 10 THEN dept_up := 2.0;
               WHEN 20 THEN dept_up := 2.5;
               WHEN 30 THEN dept_up := 3.0;
               WHEN 40 THEN dept_up := 3.5;
            ELSE EXIT;
            END CASE;
                  UPDATE emp SET sal = TRUNC(sal * dept_up)
                  WHERE CURRENT OF emp_cr;
      END LOOP;
  CLOSE emp_cr;
END;
/
